package fr.amap.commons.util.swing.jprogress;

import java.util.Collections;
import java.util.List;
import java.util.concurrent.CopyOnWriteArrayList;
import net.jcip.annotations.ThreadSafe;

/**
 * Implement it for objects which can have a linked progress bar.
 */
@ThreadSafe
public abstract class JProgressable {
    
    private final List<JProgressListener> listeners;

    public JProgressable() {
        this.listeners = new CopyOnWriteArrayList();
    }
    
    public final void addProgressListener(final JProgressListener listener) {
        listeners.add(listener);
    }

    public final List<JProgressListener> getProgressListeners() {
        return Collections.unmodifiableList(listeners);
    }
    
}
